%if 0%{?fedora}
%global with_devel 1
%global with_bundled 1
%global with_debug 0
%global with_check 1
%global with_unit_test 1
%else
%global with_devel 0
%global with_bundled 1
%global with_debug 0
%global with_check 1
%global with_unit_test 0
%endif

# Determine if systemd will be used
%if ( 0%{?fedora} && 0%{?fedora} > 16 ) || ( 0%{?rhel} && 0%{?rhel} > 6 )
%global with_systemd 1
%endif

%if 0%{?with_debug}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%global provider        github
%global provider_tld    com
%global project         heketi
%global repo            heketi
# https://github.com/heketi/heketi
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global import_path     %{provider_prefix}

Name:           %{repo}
Version:        9.0.0
Release:        9.5%{?dist}
Summary:        RESTful based volume management framework for GlusterFS
License:        LGPLv3+ and GPLv2
URL:            https://%{provider_prefix}
Source0:        https://%{provider_prefix}/archive/v%{version}.tar.gz
Source1:        https://%{provider_prefix}/releases/download/v%{version}/%{name}-deps-v%{version}.tar.gz

# Patches ported from upsteam heketi:
Patch0001:      0001-apps-limit-for-volumes-only-applies-to-block-volumes.patch
Patch0002:      0002-apps-add-test-cases-for-volume-limit-with-block-volu.patch
Patch0003:      0003-apps-don-t-split-gathering-important-data-across-xat.patch
Patch0004:      0004-apps-prevent-running-device-resync-with-pending-oper.patch
Patch0005:      0005-apps-add-test-that-a-pending-op-blocks-device-resync.patch
Patch0006:      0006-apps-fix-issue-where-old-BHVs-could-not-be-cleaned-u.patch
Patch0007:      0007-executors-simplify-the-mountpoint-remove-function.patch
Patch0008:      0008-executors-change-device-functions-to-take-a-new-hand.patch
Patch0009:      0009-executors-fetch-and-resolve-handle-metadata-to-devic.patch
Patch0010:      0010-executors-add-function-to-upgrade-an-old-handle.patch
Patch0011:      0011-executors-add-unit-test-functions-for-new-device-met.patch
Patch0012:      0012-api-extend-api-with-device-PvUUID-and-Paths.patch
Patch0013:      0013-apps-add-device-UpdateInfo-function.patch
Patch0014:      0014-apps-add-a-device-to-handle-conversion-function.patch
Patch0015:      0015-apps-update-paths-and-pv-uuid-of-device-info-respons.patch
Patch0016:      0016-apps-add-dbattribute-to-indicate-db-supports-ident-m.patch
Patch0017:      0017-cli-update-output-of-topology-info-and-device-info.patch
Patch0018:      0018-heketi-cli-refactor-topology-info-to-use-one-single-.patch
Patch0019:      0019-heketi-cli-allow-user-supplied-templates-for-topolog.patch
Patch0020:      0020-apps-add-a-new-multi-host-error-type-for-handling-tr.patch
Patch0021:      0021-apps-add-test-cases-for-multi-error-handling-in-tryO.patch
Patch0022:      0022-apps-add-test-case-for-no-errors-at-all-in-try-on-ho.patch
Patch0023:      0023-apps-refactor-multi-host-error-type.patch
Patch0024:      0024-apps-refactor-multi-cluster-error-type.patch
Patch0025:      0025-apps-gracefully-handle-attempts-to-clean-same-op-at-.patch
Patch0026:      0026-server-require-authentication-by-default.patch
Patch0027:      0027-testutils-add-option-to-disable-heketi-server-authen.patch
Patch0028:      0028-testutils-add-test-Helper-function-to-server-control.patch
Patch0029:      0029-functional-tests-add-a-test-case-for-heketi-server-n.patch
Patch0030:      0030-functional-tests-test-dev-node-manipulation-is-handl.patch
Patch0031:      0031-functional-tests-add-test-cases-for-removing-devices.patch
Patch0032:      0032-functional-tests-add-tests-for-missing-disabled-comm.patch
Patch0033:      0033-remote-exec-define-a-new-type-for-commands-and-group.patch
Patch0034:      0034-remote-exec-define-a-richer-command-type.patch
Patch0035:      0035-remote-exec-add-some-options-for-the-cmd-options-typ.patch
Patch0036:      0036-remote-exec-define-a-type-for-common-command-logging.patch
Patch0037:      0037-remote-exec-make-use-of-structured-command-logging-i.patch
Patch0038:      0038-executors-tag-the-glusterd-status-command-as-a-quiet.patch
Patch0039:      0039-remote-exec-fix-a-spelling-error-in-a-comment.patch
Patch0040:      0040-remote-exec-split-kube-command-execution-logic-out-o.patch
Patch0041:      0041-remote-exec-add-command-timeout-support-to-kube-exec.patch
Patch0042:      0042-remoteexec-add-a-very-simple-counter-for-extant-kube.patch
Patch0043:      0043-remoteexec-count-kube-connections-and-refuse-new-one.patch
Patch0044:      0044-executors-add-new-config-params-for-kubeexec-around-.patch
Patch0045:      0045-remote-exec-if-timeout-command-exits-log-it-like-a-t.patch
Patch0046:      0046-executors-add-a-richer-error-type-for-Device-Setup-f.patch
Patch0047:      0047-executors-return-rich-error-type-when-device-setup-f.patch
Patch0048:      0048-apps-add-a-function-to-get-all-device-uuids-for-devi.patch
Patch0049:      0049-apps-only-permit-passing-of-destroy-data-flag-when-s.patch
Patch0050:      0050-apps-remove-old-device-registration-feature.patch
Patch0051:      0051-functional-tests-test-for-adding-removing-devices-wi.patch
Patch0052:      0052-etc-remove-the-default-secrets-from-heketi.json.patch
Patch0053:      0053-apps-glusterfs-updateMountInfo-takes-v.info-as-input.patch
Patch0054:      0054-apps-glusterfs-the-volume-info-response-should-have-.patch
Patch0055:      0055-apps-glusterfs-update-test-to-match-new-behavior.patch
Patch0056:      0056-cli-add-volume-patch-endpoint-command.patch
Patch0057:      0057-all-change-default-volume-options-for-heketidbstorag.patch
Patch0058:      0058-client-simplify-behavior-when-custom-options-are-spe.patch
Patch0059:      0059-client-rename-the-new-default-options-var-for-clarit.patch
Patch0060:      0060-client-add-cli-option-for-appending-to-default-volum.patch
Patch0061:      0061-executors-add-a-volume-modify-function-to-the-comman.patch
Patch0062:      0062-executors-add-the-VolumeModify-function-to-the-execu.patch
Patch0063:      0063-apps-add-a-configuration-option-to-force-the-app-to-.patch
Patch0064:      0064-apps-add-function-to-update-a-volume-with-heketdbsto.patch
Patch0065:      0065-main-add-an-offline-update-dbvol-command.patch
Patch0066:      0066-tests-add-functional-tests-for-update-dbvol-command.patch
Patch0067:      0067-apps-do-not-emit-error-log-line-even-when-db-open-is.patch
Patch0068:      0068-cli-make-topology-print-removed-rather-than-failed-s.patch
Patch0069:      0069-cli-use-state-naming-filter-function-consistently.patch
Patch0070:      0070-fix-inconsistent-db-after-failing-volume-expand-oper.patch
Patch0071:      0071-cmdexec-add-lvmCommand-and-LVMWrapper.patch
Patch0072:      0072-cmdexec-run-udevadm-through-the-LVM-wrapper-as-well.patch
Patch0073:      0073-tests-add-LVMWrapper-test.patch
Patch0074:      0074-cmdexec-prevent-a-crash-by-checking-error-return-in-.patch
Patch0075:      0075-reintroduce-rest-framework-into-source-tree.patch
Patch0076:      0076-client-move-response-polling-delay-to-central-functi.patch
Patch0077:      0077-client-add-function-for-getting-default-client-optio.patch
Patch0078:      0078-client-use-shorter-poll-delay-in-unit-tests.patch
Patch0079:      0079-apps-refactor-brickNameMap-function-to-create-brickH.patch
Patch0080:      0080-apps-establish-constants-for-a-new-brick-evict-opera.patch
Patch0081:      0081-apps-create-a-new-operation-for-brick-eviction.patch
Patch0082:      0082-apps-make-brick-evict-operation-loadable.patch
Patch0083:      0083-apps-implement-a-basic-test-for-brick-evict-operatio.patch
Patch0084:      0084-apps-add-a-test-to-verify-brick-evict-op-blocks-inva.patch
Patch0085:      0085-apps-add-a-brick-evict-operation-error-handling-test.patch
Patch0086:      0086-apps-add-another-brick-evict-operation-error-handlin.patch
Patch0087:      0087-apps-add-test-for-invalid-pending-op-condition.patch
Patch0088:      0088-apps-add-test-to-cover-failure-case-where-new-brick-.patch
Patch0089:      0089-api-add-a-empty-options-type-for-brick-evict.patch
Patch0090:      0090-apps-add-brick-evict-endpoint-to-the-api.patch
Patch0091:      0091-client-add-api-function-for-brick-evict.patch
Patch0092:      0092-client-add-new-brick-evict-cli-subcommand.patch
Patch0093:      0093-apps-fix-typo-in-log-line-in-brick-evict-operation.patch
Patch0094:      0094-apps-do-not-cache-device-id-that-s-only-used-in-one-.patch
Patch0095:      0095-apps-have-brick-evict-distinguish-between-unknown-an.patch
Patch0096:      0096-apps-add-additional-debug-logging-in-brick-evict-ope.patch
Patch0097:      0097-apps-fix-usage-of-db-when-already-in-a-transaction.patch
Patch0098:      0098-apps-add-parent-and-child-pending-operation-change-t.patch
Patch0099:      0099-apps-add-helper-functions-to-make-it-easier-to-manag.patch
Patch0100:      0100-apps-prevent-child-operations-from-being-automatical.patch
Patch0101:      0101-apps-add-function-to-get-all-removeable-bricks.patch
Patch0102:      0102-apps-chain-the-errors-found-when-setting-device-stat.patch
Patch0103:      0103-apps-rework-remove-device-so-it-uses-evict-brick-chi.patch
Patch0104:      0104-apps-add-test-case-for-device-remove-when-the-child-.patch
Patch0105:      0105-apps-add-test-case-for-running-clean-funcs-on-device.patch
Patch0106:      0106-apps-make-device-remove-a-loadable-operation.patch
Patch0107:      0107-functional-tests-add-test-cases-for-new-device-remov.patch
Patch0108:      0108-apps-fix-test-now-that-device-remove-is-loadable-cle.patch
Patch0109:      0109-logging-quiet-block-cli-create-output.patch
Patch0110:      0110-logging-format-block-cli-create-output.patch
Patch0111:      0111-apps-Fix-regression-in-brickEvict-execGetReplacmentI.patch
Patch0112:      0112-apps-work-around-issue-evicting-destroying-old-brick.patch
Patch0113:      0113-apps-try-and-use-a-working-node-where-possible-durin.patch
Patch0114:      0114-apps-only-treat-errors-as-fatal-if-brick-destroy-fai.patch

# CNS-specific patches:


# e.g. el6 has ppc64 arch without gcc-go, so EA tag is required
%if 0%{?fedora} || 0%{?centos}
ExclusiveArch:  %{?go_arches:%{go_arches}}%{!?go_arches:%{ix86} x86_64 %{arm}}
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires:  %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}
%else
BuildRequires: go-toolset-7
BuildRequires: openssl-devel
%endif

Requires(pre):  shadow-utils

%if 0%{?with_systemd}
BuildRequires:  systemd
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
%else
Requires(post):   /sbin/chkconfig
Requires(preun):  /sbin/service
Requires(preun):  /sbin/chkconfig
Requires(postun): /sbin/service
%endif

%description
Heketi provides a RESTful management interface which can be used to manage
the life cycle of GlusterFS volumes.  With Heketi, cloud services like
OpenStack Manila, Kubernetes, and OpenShift can dynamically provision
GlusterFS volumes with any of the supported durability types.  Heketi
will automatically determine the location for bricks across the cluster,
making sure to place bricks and its replicas across different failure
domains.  Heketi also supports any number of GlusterFS clusters, allowing
cloud services to provide network file storage without being limited to a
single GlusterFS cluster.

%if 0%{?with_devel}
%package devel
Summary:       %{summary}
BuildArch:     noarch

%if 0%{?with_check} && ! 0%{?with_bundled}
BuildRequires: golang(github.com/auth0/go-jwt-middleware)
BuildRequires: golang(github.com/boltdb/bolt)
BuildRequires: golang(github.com/codegangsta/negroni)
BuildRequires: golang(github.com/dgrijalva/jwt-go)
BuildRequires: golang(github.com/gorilla/context)
BuildRequires: golang(github.com/gorilla/mux)
BuildRequires: golang(github.com/lpabon/godbc)
BuildRequires: golang(golang.org/x/crypto/ssh)
BuildRequires: golang(golang.org/x/crypto/ssh/agent)
%endif

%if 0%{?with_bundled} && 0%{?fedora}
Provides: bundled(golang(github.com/auth0/go-jwt-middleware)) = 8c897f7c3631a9e9405b9496fd8ce241acdef230
Provides: bundled(golang(github.com/boltdb/bolt)) = 980670afcebfd86727505b3061d8667195234816
Provides: bundled(golang(github.com/codegangsta/negroni)) = c7477ad8e330bef55bf1ebe300cf8aa67c492d1b
Provides: bundled(golang(github.com/dgrijalva/jwt-go)) = 5ca80149b9d3f8b863af0e2bb6742e608603bd99
Provides: bundled(golang(github.com/gorilla/context)) = 215affda49addc4c8ef7e2534915df2c8c35c6cd
Provides: bundled(golang(github.com/gorilla/mux)) = f15e0c49460fd49eebe2bcc8486b05d1bef68d3a
Provides: bundled(golang(github.com/lpabon/godbc)) = 9577782540c1398b710ddae1b86268ba03a19b0c
Provides: bundled(golang(golang.org/x/crypto/ssh)) = fcdb74e78f2621098ebc0376bbadffcf580ccfe4
Provides: bundled(golang(golang.org/x/crypto/ssh/agent)) = fcdb74e78f2621098ebc0376bbadffcf580ccfe4
%endif

Provides:      golang(%{import_path}/apps) = %{version}-%{release}
Provides:      golang(%{import_path}/apps/glusterfs) = %{version}-%{release}
Provides:      golang(%{import_path}/client/api/go-client) = %{version}-%{release}
Provides:      golang(%{import_path}/client/cli/go/commands) = %{version}-%{release}
Provides:      golang(%{import_path}/executors) = %{version}-%{release}
Provides:      golang(%{import_path}/executors/mockexec) = %{version}-%{release}
Provides:      golang(%{import_path}/executors/sshexec) = %{version}-%{release}
Provides:      golang(%{import_path}/middleware) = %{version}-%{release}
Provides:      golang(%{import_path}/rest) = %{version}-%{release}
Provides:      golang(%{import_path}/tests) = %{version}-%{release}
Provides:      golang(%{import_path}/utils) = %{version}-%{release}
Provides:      golang(%{import_path}/utils/ssh) = %{version}-%{release}

%description devel
%{summary}

This package contains library source intended for
building other packages which use import path with
%{import_path} prefix.
%endif

%if 0%{?with_unit_test} && 0%{?with_devel}
%package unit-test-devel
Summary:         Unit tests for %{name} package
%if 0%{?fedora} || 0%{?centos}
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires:  %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}
%else
BuildRequires: go-toolset-7
BuildRequires: openssl-devel
%endif

%if 0%{?with_check}
#Here comes all BuildRequires: PACKAGE the unit tests
#in %%check section need for running
%endif

# test subpackage tests code from devel subpackage
Requires:        %{name}-devel = %{version}-%{release}

%description unit-test-devel
%{summary}

This package contains unit tests for project
providing packages with %{import_path} prefix.
%endif

%package client
Summary:        Command line client for Heketi
Group:          System Environment/Libraries
License:        LGPLv3+ and GPLv2

%description client
%{summary}

Command line program to interact with Heketi


%package -n python-heketi
Summary:        Python libraries for Heketi
Group:          System Environment/Libraries
License:        ASL 2.0 and LGPLv3+
Requires:       python-jwt
Requires:       python-requests
BuildRequires:  python-setuptools
BuildRequires:  python2-devel

%description -n python-heketi
%{summary}

This package contains python libraries for interacting with Heketi

%{?enable_gotoolset7}
%prep
%setup -q

# upstream heketi patches
%patch0001 -p1 -b .0001-apps-limit-for-volumes-only-applies-to-block-volumes.patch
%patch0002 -p1 -b .0002-apps-add-test-cases-for-volume-limit-with-block-volu.patch
%patch0003 -p1 -b .0003-apps-don-t-split-gathering-important-data-across-xat.patch
%patch0004 -p1 -b .0004-apps-prevent-running-device-resync-with-pending-oper.patch
%patch0005 -p1 -b .0005-apps-add-test-that-a-pending-op-blocks-device-resync.patch
%patch0006 -p1 -b .0006-apps-fix-issue-where-old-BHVs-could-not-be-cleaned-u.patch
%patch0007 -p1 -b .0007-executors-simplify-the-mountpoint-remove-function.patch
%patch0008 -p1 -b .0008-executors-change-device-functions-to-take-a-new-hand.patch
%patch0009 -p1 -b .0009-executors-fetch-and-resolve-handle-metadata-to-devic.patch
%patch0010 -p1 -b .0010-executors-add-function-to-upgrade-an-old-handle.patch
%patch0011 -p1 -b .0011-executors-add-unit-test-functions-for-new-device-met.patch
%patch0012 -p1 -b .0012-api-extend-api-with-device-PvUUID-and-Paths.patch
%patch0013 -p1 -b .0013-apps-add-device-UpdateInfo-function.patch
%patch0014 -p1 -b .0014-apps-add-a-device-to-handle-conversion-function.patch
%patch0015 -p1 -b .0015-apps-update-paths-and-pv-uuid-of-device-info-respons.patch
%patch0016 -p1 -b .0016-apps-add-dbattribute-to-indicate-db-supports-ident-m.patch
%patch0017 -p1 -b .0017-cli-update-output-of-topology-info-and-device-info.patch
%patch0018 -p1 -b .0018-heketi-cli-refactor-topology-info-to-use-one-single-.patch
%patch0019 -p1 -b .0019-heketi-cli-allow-user-supplied-templates-for-topolog.patch
%patch0020 -p1 -b .0020-apps-add-a-new-multi-host-error-type-for-handling-tr.patch
%patch0021 -p1 -b .0021-apps-add-test-cases-for-multi-error-handling-in-tryO.patch
%patch0022 -p1 -b .0022-apps-add-test-case-for-no-errors-at-all-in-try-on-ho.patch
%patch0023 -p1 -b .0023-apps-refactor-multi-host-error-type.patch
%patch0024 -p1 -b .0024-apps-refactor-multi-cluster-error-type.patch
%patch0025 -p1 -b .0025-apps-gracefully-handle-attempts-to-clean-same-op-at-.patch
%patch0026 -p1 -b .0026-server-require-authentication-by-default.patch
%patch0027 -p1 -b .0027-testutils-add-option-to-disable-heketi-server-authen.patch
%patch0028 -p1 -b .0028-testutils-add-test-Helper-function-to-server-control.patch
%patch0029 -p1 -b .0029-functional-tests-add-a-test-case-for-heketi-server-n.patch
%patch0030 -p1 -b .0030-functional-tests-test-dev-node-manipulation-is-handl.patch
%patch0031 -p1 -b .0031-functional-tests-add-test-cases-for-removing-devices.patch
%patch0032 -p1 -b .0032-functional-tests-add-tests-for-missing-disabled-comm.patch
%patch0033 -p1 -b .0033-remote-exec-define-a-new-type-for-commands-and-group.patch
%patch0034 -p1 -b .0034-remote-exec-define-a-richer-command-type.patch
%patch0035 -p1 -b .0035-remote-exec-add-some-options-for-the-cmd-options-typ.patch
%patch0036 -p1 -b .0036-remote-exec-define-a-type-for-common-command-logging.patch
%patch0037 -p1 -b .0037-remote-exec-make-use-of-structured-command-logging-i.patch
%patch0038 -p1 -b .0038-executors-tag-the-glusterd-status-command-as-a-quiet.patch
%patch0039 -p1 -b .0039-remote-exec-fix-a-spelling-error-in-a-comment.patch
%patch0040 -p1 -b .0040-remote-exec-split-kube-command-execution-logic-out-o.patch
%patch0041 -p1 -b .0041-remote-exec-add-command-timeout-support-to-kube-exec.patch
%patch0042 -p1 -b .0042-remoteexec-add-a-very-simple-counter-for-extant-kube.patch
%patch0043 -p1 -b .0043-remoteexec-count-kube-connections-and-refuse-new-one.patch
%patch0044 -p1 -b .0044-executors-add-new-config-params-for-kubeexec-around-.patch
%patch0045 -p1 -b .0045-remote-exec-if-timeout-command-exits-log-it-like-a-t.patch
%patch0046 -p1 -b .0046-executors-add-a-richer-error-type-for-Device-Setup-f.patch
%patch0047 -p1 -b .0047-executors-return-rich-error-type-when-device-setup-f.patch
%patch0048 -p1 -b .0048-apps-add-a-function-to-get-all-device-uuids-for-devi.patch
%patch0049 -p1 -b .0049-apps-only-permit-passing-of-destroy-data-flag-when-s.patch
%patch0050 -p1 -b .0050-apps-remove-old-device-registration-feature.patch
%patch0051 -p1 -b .0051-functional-tests-test-for-adding-removing-devices-wi.patch
%patch0052 -p1 -b .0052-etc-remove-the-default-secrets-from-heketi.json.patch
%patch0053 -p1 -b .0053-apps-glusterfs-updateMountInfo-takes-v.info-as-input.patch
%patch0054 -p1 -b .0054-apps-glusterfs-the-volume-info-response-should-have-.patch
%patch0055 -p1 -b .0055-apps-glusterfs-update-test-to-match-new-behavior.patch
%patch0056 -p1 -b .0056-cli-add-volume-patch-endpoint-command.patch
%patch0057 -p1 -b .0057-all-change-default-volume-options-for-heketidbstorag.patch
%patch0058 -p1 -b .0058-client-simplify-behavior-when-custom-options-are-spe.patch
%patch0059 -p1 -b .0059-client-rename-the-new-default-options-var-for-clarit.patch
%patch0060 -p1 -b .0060-client-add-cli-option-for-appending-to-default-volum.patch
%patch0061 -p1 -b .0061-executors-add-a-volume-modify-function-to-the-comman.patch
%patch0062 -p1 -b .0062-executors-add-the-VolumeModify-function-to-the-execu.patch
%patch0063 -p1 -b .0063-apps-add-a-configuration-option-to-force-the-app-to-.patch
%patch0064 -p1 -b .0064-apps-add-function-to-update-a-volume-with-heketdbsto.patch
%patch0065 -p1 -b .0065-main-add-an-offline-update-dbvol-command.patch
%patch0066 -p1 -b .0066-tests-add-functional-tests-for-update-dbvol-command.patch
%patch0067 -p1 -b .0067-apps-do-not-emit-error-log-line-even-when-db-open-is.patch
%patch0068 -p1 -b .0068-cli-make-topology-print-removed-rather-than-failed-s.patch
%patch0069 -p1 -b .0069-cli-use-state-naming-filter-function-consistently.patch
%patch0070 -p1 -b .0070-fix-inconsistent-db-after-failing-volume-expand-oper.patch
%patch0071 -p1 -b .0071-cmdexec-add-lvmCommand-and-LVMWrapper.patch
%patch0072 -p1 -b .0072-cmdexec-run-udevadm-through-the-LVM-wrapper-as-well.patch
%patch0073 -p1 -b .0073-tests-add-LVMWrapper-test.patch
%patch0074 -p1 -b .0074-cmdexec-prevent-a-crash-by-checking-error-return-in-.patch
%patch0075 -p1 -b .0075-reintroduce-rest-framework-into-source-tree.patch
%patch0076 -p1 -b .0076-client-move-response-polling-delay-to-central-functi.patch
%patch0077 -p1 -b .0077-client-add-function-for-getting-default-client-optio.patch
%patch0078 -p1 -b .0078-client-use-shorter-poll-delay-in-unit-tests.patch
%patch0079 -p1 -b .0079-apps-refactor-brickNameMap-function-to-create-brickH.patch
%patch0080 -p1 -b .0080-apps-establish-constants-for-a-new-brick-evict-opera.patch
%patch0081 -p1 -b .0081-apps-create-a-new-operation-for-brick-eviction.patch
%patch0082 -p1 -b .0082-apps-make-brick-evict-operation-loadable.patch
%patch0083 -p1 -b .0083-apps-implement-a-basic-test-for-brick-evict-operatio.patch
%patch0084 -p1 -b .0084-apps-add-a-test-to-verify-brick-evict-op-blocks-inva.patch
%patch0085 -p1 -b .0085-apps-add-a-brick-evict-operation-error-handling-test.patch
%patch0086 -p1 -b .0086-apps-add-another-brick-evict-operation-error-handlin.patch
%patch0087 -p1 -b .0087-apps-add-test-for-invalid-pending-op-condition.patch
%patch0088 -p1 -b .0088-apps-add-test-to-cover-failure-case-where-new-brick-.patch
%patch0089 -p1 -b .0089-api-add-a-empty-options-type-for-brick-evict.patch
%patch0090 -p1 -b .0090-apps-add-brick-evict-endpoint-to-the-api.patch
%patch0091 -p1 -b .0091-client-add-api-function-for-brick-evict.patch
%patch0092 -p1 -b .0092-client-add-new-brick-evict-cli-subcommand.patch
%patch0093 -p1 -b .0093-apps-fix-typo-in-log-line-in-brick-evict-operation.patch
%patch0094 -p1 -b .0094-apps-do-not-cache-device-id-that-s-only-used-in-one-.patch
%patch0095 -p1 -b .0095-apps-have-brick-evict-distinguish-between-unknown-an.patch
%patch0096 -p1 -b .0096-apps-add-additional-debug-logging-in-brick-evict-ope.patch
%patch0097 -p1 -b .0097-apps-fix-usage-of-db-when-already-in-a-transaction.patch
%patch0098 -p1 -b .0098-apps-add-parent-and-child-pending-operation-change-t.patch
%patch0099 -p1 -b .0099-apps-add-helper-functions-to-make-it-easier-to-manag.patch
%patch0100 -p1 -b .0100-apps-prevent-child-operations-from-being-automatical.patch
%patch0101 -p1 -b .0101-apps-add-function-to-get-all-removeable-bricks.patch
%patch0102 -p1 -b .0102-apps-chain-the-errors-found-when-setting-device-stat.patch
%patch0103 -p1 -b .0103-apps-rework-remove-device-so-it-uses-evict-brick-chi.patch
%patch0104 -p1 -b .0104-apps-add-test-case-for-device-remove-when-the-child-.patch
%patch0105 -p1 -b .0105-apps-add-test-case-for-running-clean-funcs-on-device.patch
%patch0106 -p1 -b .0106-apps-make-device-remove-a-loadable-operation.patch
%patch0107 -p1 -b .0107-functional-tests-add-test-cases-for-new-device-remov.patch
%patch0108 -p1 -b .0108-apps-fix-test-now-that-device-remove-is-loadable-cle.patch
%patch0109 -p1 -b .0109-logging-quiet-block-cli-create-output.patch
%patch0110 -p1 -b .0110-logging-format-block-cli-create-output.patch
%patch0111 -p1 -b .0111-apps-Fix-regression-in-brickEvict-execGetReplacmentI.patch
%patch0112 -p1 -b .0112-apps-work-around-issue-evicting-destroying-old-brick.patch
%patch0113 -p1 -b .0113-apps-try-and-use-a-working-node-where-possible-durin.patch
%patch0114 -p1 -b .0114-apps-only-treat-errors-as-fatal-if-brick-destroy-fai.patch

# CNS-specific patches

%build
mkdir -p src/%{provider}.%{provider_tld}/%{project}
ln -s $(pwd) src/%{provider}.%{provider_tld}/%{project}/%{repo}

# ! Bundled
%if ! 0%{?with_bundled}
export GOPATH=$(pwd):%{?gopath}
export LDFLAGS="-X main.HEKETI_VERSION=%{version}-%{release}"
%gobuild -o %{name}

export LDFLAGS="-X main.HEKETI_CLI_VERSION=%{version}-%{release}"
cd client/cli/go
%gobuild -o %{name}-cli
cd ../../..
%else

# Bundled

# workaround for vendor directory which doesn't have src
# which is needed by the GOPATH
mkdir -p ./src
tar -xvf %{SOURCE1} -C ./src/

# Setup GOPATH
export GOPATH=$(pwd):%{?gopath}

%define gohash %(head -c20 /dev/urandom | od -An -tx1 | tr -d '\ \\n')

# -s strips debug information
go build -ldflags "-X main.HEKETI_VERSION=%{version}-%{release} -B 0x%{gohash} -s -extldflags '-z relro -z now'" -o %{name}

cd client/cli/go
go build -ldflags "-X main.HEKETI_CLI_VERSION=%{version}-%{release} -X github.com/heketi/heketi/client/cli/go/cmds.HeketiStorageJobContainer=rhgs3/rhgs-volmanager-rhel7:v3.11 -B 0x%{gohash} -s -extldflags '-z relro -z now'" -o %{name}-cli

cd ../../..

%endif

# Python
cd client/api/python
%{__python2} setup.py build

%install
# Python
cd client/api/python
%{__python2} setup.py install -O1 --skip-build --root %{buildroot}
cd ../../..

install -D -p -m 0755 client/cli/go/%{name}-cli.sh \
  %{buildroot}%{_datadir}/bash-completion/completions/%{name}-cli.sh
install -D -p -m 0755 %{name} %{buildroot}%{_bindir}/%{name}
install -D -p -m 0755 client/cli/go/%{name}-cli %{buildroot}%{_bindir}/%{name}-cli
install -d -m 0755 %{buildroot}%{_sysconfdir}/%{name}
install -D -p -m 0600 etc/%{name}.json %{buildroot}%{_sysconfdir}/%{name}/%{name}.json
install -D -p -m 0644 docs/man/heketi-cli.8 %{buildroot}%{_mandir}/man8/heketi-cli.8
install -D -p -m 0644 client/cli/go/topology-sample.json \
  %{buildroot}%{_datadir}/%{name}/topology-sample.json

%if 0%{?with_systemd}
install -D -p -m 0644 extras/systemd/heketi.service %{buildroot}%{_unitdir}/%{name}.service
%else
install -D -p -m 0755 extras/etc/init/heketi.initd %{buildroot}%{_sysconfdir}/init.d/%{name}
%endif

# And create /var/lib/heketi
install -d -m 0755 %{buildroot}%{_sharedstatedir}/%{name}


# source codes for building projects
%if 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
echo "%%dir %%{gopath}/src/%%{import_path}/." >> devel.file-list
# find all *.go but no *_test.go files and generate devel.file-list
for file in $(find . -iname "*.go" \! -iname "*_test.go") ; do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list
done
%endif

# testing files for this project
%if 0%{?with_unit_test} && 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
# find all *_test.go files and generate unit-test-devel.file-list
for file in $(find . -iname "*_test.go"); do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> unit-test-devel.file-list
done
%endif

%if 0%{?with_devel}
sort -u -o devel.file-list devel.file-list
%endif

%check
%if 0%{?with_check} && 0%{?with_unit_test} && 0%{?with_devel}

%if ! 0%{?with_bundled}
export GOPATH=%{buildroot}/%{gopath}:%{gopath}
%gotest %{import_path}/apps/glusterfs
%gotest %{import_path}/client/api/go-client
%gotest %{import_path}/middleware
%else
export GOPATH=$(pwd):%{gopath}
go test -v %{import_path}/apps/glusterfs
go test -v %{import_path}/client/api/go-client
go test -v %{import_path}/middleware
go test -v %{import_path}/executors/kubeexec
go test -v %{import_path}/executors/sshexec
%endif
%endif

%pre
getent group %{name} >/dev/null || groupadd -r %{name}
getent passwd %{name} >/dev/null || useradd -r -g %{name} -d %{_sharedstatedir}/%{name} -s /sbin/nologin -c "heketi user" %{name}

%post
%if 0%{?with_systemd}
%systemd_post %{name}.service
%else
/sbin/chkconfig --add %{name}
%endif

%preun
%if 0%{?with_systemd}
%systemd_preun %{name}.service
%else
/sbin/service %{name} stop &> /dev/null
%endif

%postun
%if 0%{?with_systemd}
%systemd_postun %{name}.service
%else
/sbin/chkconfig --del %{name}
%endif


#define license tag if not already defined
%{!?_licensedir:%global license %doc}

%files
%license LICENSE
%doc README.md AUTHORS
%config(noreplace) %{_sysconfdir}/%{name}
%{_bindir}/%{name}
%dir %attr(-,%{name},%{name}) %{_sharedstatedir}/%{name}
%attr(-, heketi, heketi) %{_sysconfdir}/%{name}/%{name}.json
%if 0%{?with_systemd}
%{_unitdir}/%{name}.service
%else
%{_sysconfdir}/init.d/%{name}
%endif

%files -n python-heketi
%license LICENSE
%doc README.md AUTHORS
%{python_sitelib}/heketi
%{python_sitelib}/heketi-*.egg-info

%files client
%license LICENSE
%doc README.md AUTHORS
%{_bindir}/%{name}-cli
%{_datadir}/%{name}/topology-sample.json
%{_mandir}/man8/heketi-cli.8*
%{_datadir}/bash-completion/completions/%{name}-cli.sh

%if 0%{?with_devel}
%files devel -f devel.file-list
%license LICENSE
%doc README.md AUTHORS
%dir %{gopath}/src/%{provider}.%{provider_tld}/%{project}
%dir %{gopath}/src/%{import_path}
%endif

%if 0%{?with_unit_test} && 0%{?with_devel}
%files unit-test-devel -f unit-test-devel.file-list
%license LICENSE
%doc README.md AUTHORS
%endif

%changelog
* Wed Jul 29 2020 Nitin Goyal <nigoyal@redhat.com> - 9.0.0-9.5
- Resolves: #1855178 - brickEvict/deviceRemove is not working when node is unreachable

* Mon Jul 13 2020 Nitin Goyal <nigoyal@redhat.com> - 9.0.0-9.4
- Resolves: #1855178 - brickEvict/deviceRemove is not working when node is unreachable

* Wed Jul 01 2020 Nitin Goyal <nigoyal@redhat.com> - 9.0.0-9.3
- Resolves: #1845388 - Fix CVE-2020-10763
- Resolves: #1812122 - Improve the reliability of device remove

* Tue Jun 30 2020 Nitin Goyal <nigoyal@redhat.com> - 9.0.0-9.2
- Resolves: #1845388 - Fix CVE-2020-10763
- Resolves: #1812122 - Improve the reliability of device remove

* Mon Jun 29 2020 Nitin Goyal <nigoyal@redhat.com> - 9.0.0-9.1
- Resolves: #1845388 - Fix CVE-2020-10763
- Resolves: #1812122 - Improve the reliability of device remove

* Wed Jan 29 2020 Raghavendra Talur <rtalur@redhat.com> - 9.0.0-9
- Resolves: #1796059 - Heketi crashes if the pod is not running on the node during brick remove

* Tue Dec 10 2019 Raghavendra Talur <rtalur@redhat.com> - 9.0.0-8
- Resolves: #1718982 - Heketi spec contains old reference to image tag
- Resolves: #1653567 - Incorrect used and free space shown in heketi topology info
- Resolves: #1710685 - After a device is removed from heketi, status of the device is different in device info and node info
- Resolves: #1756861 - Automatically tune heketidbstorage for safer workloads (on container start)
- Resolves: #1772612 - heketi should call the wrapper LVM scripts instead of the lvm binaries in the gluster container

* Wed Sep 18 2019 John Mulligan <jmulligan@redhat.com> - 9.0.0-7
- Resolves: #1740884 - tune hekeitidbstorage for safety of db workload

* Tue Sep 10 2019 Raghavendra Talur <rtalur@redhat.com> - 9.0.0-6
- Resolves: #1710996 - Reset default limit for maximum number of volumes in Heketi to upstream value of 1000

* Mon Jul 22 2019 Raghavendra Talur <rtalur@redhat.com> - 9.0.0-5
- Resolves: #1710996 - Increase default limit for maximum number of volumes in Heketi

* Sun Jul 21 2019 Raghavendra Talur <rtalur@redhat.com> - 9.0.0-4
- Resolves: #1660681 - Heketi does not list storage endpoint of newly added node

* Mon Jul 08 2019 Raghavendra Talur <rtalur@redhat.com> - 9.0.0-3
- Resolves: #1636912 - PVC still in pending state after node shutdown and start - heketi kube exec layer got stuck
- Resolves: #1725798 - Deleted device cannot be added back to the topology after device path change
- Resolves: #1701838 - CVE-2019-3899 heketi: heketi can be installed using insecure defaults

* Tue Jun 18 2019 Raghavendra Talur <rtalur@redhat.com> - 9.0.0-2
- Resolves: #1710080 - [RFE] Rebase Heketi to version v9.0 upstream source
- Resolves: #1609553 - [RFE] Automatically map /dev paths to stable /dev/disk/by-* paths for long term use
- Resolves: #1702162 - Heketi Pod crashed unexpectedly initializing operations cleanup
- Resolves: #1577803 - [RFE] heketi is not showing expected error when we give same name of the vol.
- Resolves: #1701838 - CVE-2019-3899 heketi: heketi can be installed using insecure defaults

* Fri Jun 14 2019 Raghavendra Talur <rtalur@redhat.com> - 9.0.0-1
- Resolves: #1710080 - [RFE] Rebase Heketi to version v9.0 upstream source
- Resolves: #1609553 - [RFE] Automatically map /dev paths to stable /dev/disk/by-* paths for long term use
- Resolves: #1702162 - Heketi Pod crashed unexpectedly initializing operations cleanup
- Resolves: #1577803 - [RFE] heketi is not showing expected error when we give same name of the vol.
- Resolves: #1701838 - CVE-2019-3899 heketi: heketi can be installed using insecure defaults

* Fri May 10 2019 John Mulligan <jmulligan@redhat.com> - 8.0.0-12
* Resolves: #1476223 - add option to limit number of heketi volumes which can be created on heketi cluster

* Mon Apr 08 2019 John Mulligan <jmulligan@redhat.com> - 8.0.0-11
- Resolves: #1691509 - Provide a way for heketi to start in an "administrative mode"
- Resolves: #1685005 - Heketi sets "user.heketi.zone-checking" to strict or none based on DC/template settings & not based on settings in the SC used
- Resolves: #1476223 - add option to limit number of heketi volumes which can be created on heketi cluster

* Wed Feb 27 2019 John Mulligan <jmulligan@redhat.com> - 8.0.0-10
- Resolves: #1680468 - Volume creation fails with HEKETI_ZONE_CHECKING set to "strict"

* Wed Feb 13 2019 John Mulligan <jmulligan@redhat.com> - 8.0.0-9
- Resolves: #1589012 - Block-volume details not listed in heketi metrics
- Resolves: #1635204 - Heketi should choose replica brick from different zone for volume creation
- Resolves: #1665386 - heketi device deletion command is deleting vg when we are executing delete command without disabling and removing the device
- Resolves: #1667797 - pendingoperations total count is always zero in "heketi-cli db check" output
- Resolves: #1668181 - heketi fails to cleanup stale block entries
- Resolves: #1669935 - heketi is giving inappropriate Error when id is not present for "heketi-cli server operations info id"

* Fri Jan 11 2019 John Mulligan <jmulligan@redhat.com> - 8.0.0-8
- Resolves: #1662141 - heketi intermittently lists fewer volumes than the total volumes present with Error: Id not found

* Thu Dec 27 2018 John Mulligan <jmulligan@redhat.com> - 8.0.0-7
- Resolves: #1640027 - heketi metrics displayed for disk parameters in prometheus graph and console are incorrect.

* Sun Dec 23 2018 John Mulligan <jmulligan@redhat.com> - 8.0.0-6
- Resolves: #1641680 - Add ability to heketi server to output diagnostics information for OCS
- Resolves: #1661517 - heketi-cli volume list returns Error: Id not found

* Wed Dec 19 2018 John Mulligan <jmulligan@redhat.com> - 8.0.0-5
- Resolves: #1641680 - Add ability to heketi server to output diagnostics information for OCS

* Tue Dec 18 2018 John Mulligan <jmulligan@redhat.com> - 8.0.0-4
- Resolves: #1641668 - Add ability for heketi server to automatically resolve stale or failed operations
- Resolves: #1641680 - Add ability to heketi server to output diagnostics information for OCS

* Thu Dec 13 2018 Michael Adam <obnox@redhat.com> - 8.0.0-3
- Resolves: #1651041 - Higher gluster cli timeout value in all gluster cli commands

* Sun Dec 02 2018 Raghavendra Talur <rtalur@redhat.com> - 8.0.0-2
- Resolves: #1640027 - heketi metrics displayed for disk parameters in prometheus graph and console are incorrect.

* Tue Nov 13 2018 Raghavendra Talur <rtalur@redhat.com> - 8.0.0-1
- Resolves: #1647016 - Rebase heketi to version 8

* Mon Oct 15 2018 John Mulligan <jmulligan@redhat.com> - 7.0.0-15
- Resolves: #1638316 - heketi is giving error on deletion of block device "Error: Volume 2be96a5cba8e68184eb0e488934ab75c free size may not be set greater than 100"

* Wed Oct 03 2018 Raghavendra Talur <rtalur@redhat.com> - 7.0.0-14
- Resolves: #1632719 - [heketi workaround] With only 1 node down, multipath -ll shows multiple paths in "failed" state

* Wed Sep 26 2018 Michael Adam <obnox@redhat.com> - 7.0.0-13
- Resolves: #1629889 - Device removal leaves garbage on the device returning "ok", breaking further attempts to "add" device back

* Wed Sep 26 2018 Raghavendra Talur <rtalur@redhat.com> - 7.0.0-12
- Resolves: #1629889 - Device removal leaves garbage on the device returning "ok", breaking further attempts to "add" device back

* Fri Sep 07 2018 Raghavendra Talur <rtalur@redhat.com> - 7.0.0-11
- Resolves: #1624738 - heketi-cli volume info of Block-hosting volumes lists extra block device IDs which are NOT present

* Thu Sep 06 2018 Raghavendra Talur <rtalur@redhat.com> - 7.0.0-10
- Resolves: #1624738 - heketi-cli volume info of Block-hosting volumes lists extra block device IDs which are NOT present

* Wed Sep 05 2018 Raghavendra Talur <rtalur@redhat.com> - 7.0.0-9
- Resolves: #1624738 - heketi-cli volume info of Block-hosting volumes lists extra block device IDs which are NOT present

* Fri Aug 31 2018 Michael Adam <obnox@redhat.com> - 7.0.0-8
- Resolves: #1622645 - Block app pods unable to re-mount block pvcs once BHVs have less space - I/O error
* Fri Aug 24 2018 John Mulligan <jmulligan@redhat.com> - 7.0.0-7
- Resolves: #1619515 - With Reserved size=2GB, Block PVC count mismatch between heketi and gluster & USED space greater than available space of block hosting vol
- Resolves: #1619017 - mismatch in number of block devices between heketi and gluster

* Fri Aug 10 2018 Raghavendra Talur <rtalur@redhat.com> - 7.0.0-6
- Resolves: #1541323 - [GSS] Glusterfs pvc bound fail with error creating volume Token used before issued
- Resolves: #1584191 - Heketi topology info shows incorrect used space (not zero for devices which had no bricks)
- Resolves: #1607821 - heketi is creating separate block hosting volume for every block device request
- Resolves: #1612049 - Once BZ#1584123 is hit in older heketi-build-6.0.0.7-4, block volume creations failed in latest builds with heketi panic
- Resolves: #1612058 - Arbiter brick can contain less files than expected when we specify average file size explicitly
- Resolves: #1612782 - creation of block volume is failing, but device storage is getting used
- Resolves: #1612784 - after node delete from heketi, mount point,backup-volfile-servers in volumes contains removed node IP
- Resolves: #1612786 - Newly created block volume info showing deleted node IP
- Resolves: #1613260 - CNS: heketi pod not inready state - Liveness probe failed

* Thu Jul 26 2018 Michael Adam <obnox@redhat.com> - 7.0.0-5
- Resolves: #1601341 - On a 4 node setup heketi blockvolume creation with HA=3 fails when one node is powered off
- Resolves: #1595531 - With HA=3, in a 4 node cluster, for all block devices, a fixed set of 3 IPs/Gluster Pods are used as targets, with 1 pod staying unused
- Resolves: #1596018 - Block device creation fails with sufficient space available on the devices

* Thu Jul 19 2018 Raghavendra Talur <rtalur@redhat.com> - 7.0.0-4
- Resolves: #1600066 - [GSS] Heketi creating more gluster volume than number of PVCs requested
- Resolves: #1600160 - scalability issue with gluster on OCP
- Resolves: #1601904 - Creation of file PVC is very slow when scaled up to more than 200

* Thu Jul 12 2018 Raghavendra Talur <rtalur@redhat.com> - 7.0.0-3
- Resolves: #1581864 - CNS: failed to create volume: Token used before issued
- Resolves: #1590143 - heketi device delete command hanged (as a vgremove command was waiting for an interactive prompt response)
- Resolves: #1591624 - [RFE]: Provide an option to create block hosting volume as arbiter volumes
- Resolves: #1595535 - In a 4 node CNS cluster, need to pass 3 hosts from heketi for gluster-block cli when HA is 3, instead of all 4 IPs

* Sun Jul 01 2018 Raghavendra Talur <rtalur@redhat.com> - 7.0.0-2
- Resolves: #1584123 - In a CNS setup, heketi-cli info on a block-hosting volume displays "Free Size" greater than its actual size
- Resolves: #1591437 - Heketi delete of orphaned volume returns error
- Resolves: #1592649 - free size in block hosting volume info isn't updated on expansion
- Resolves: #1596626 - Heketi stops all further operations on finding "Id Not Found" errors due to db inconsistent state

* Tue Jun 5 2018 Raghavendra Talur <rtalur@redhat.com> - 7.0.0-1
- Resolves: #1459628 - [GSS][RFE] Support Replica 2 + Arbiter volumes with Heketi

* Fri Jun 1 2018 Saravanakumar Arumugam <sarumuga@redhat.com> - 6.0.0-14
- Resolves: #1459628 - [GSS][RFE] Support Replica 2 + Arbiter volumes with Heketi

* Wed May 16 2018 Saravanakumar Arumugam <sarumuga@redhat.com> - 6.0.0-13
- Resolves: #1459628 - [GSS][RFE] Support Replica 2 + Arbiter volumes with Heketi

* Mon May 14 2018 Madhu Rajanna <mrajanna@redhat.com> - 6.0.0-12
- Resolves: #1459628 - [GSS][RFE] Support Replica 2 + Arbiter volumes with Heketi

* Thu Apr 19 2018 Madhu Rajanna <mrajanna@redhat.com> - 6.0.0-11
- Resolves: #1459628 - [GSS][RFE] Support Replica 2 + Arbiter volumes with Heketi

* Thu Mar 22 2018 Raghavendra Talur <rtalur@redhat.com> - 6.0.0-10
- Resolves: #1459628 - [GSS][RFE] Support Replica 2 + Arbiter volumes with Heketi

* Fri Mar 16 2018 Saravanakumar Arumugam <sarumuga@redhat.com> - - 6.0.0-9
- Resolves: #1557294 -  Initial build for heketi rpm for CNS 3.9.1 on RHEL7.5

* Fri Mar 16 2018 Saravanakumar Arumugam <sarumuga@redhat.com> - - 6.0.0-8
- Resolves: #1557294 -  Initial build for heketi rpm for CNS 3.9.1 on RHEL7.5

* Tue Mar 13 2018 Raghavendra Talur <rtalur@redhat.com> - 6.0.0-7
- Resolves: #1437798 - when remove device fails in the middle of migration, retrying device remove on the same device fails with error 'Id not found'
- Resolves: #1449312 - Id not found when removing a device
- Resolves: #1552733 - [Regression]: block device creation request of size greater than blockhosting volume's size should fail with proper error message
- Resolves: #1553038 - Failed to start heketi service on CRS setup (heketi outside openshift)

* Thu Mar 08 2018 Raghavendra Talur <rtalur@redhat.com> - 6.0.0-6
- Resolves: #1548322 - panic: Heketi terminated while performing one or more operations. Server will not start as long as pending operations are present in the db.

* Tue Mar 06 2018 Raghavendra Talur <rtalur@redhat.com> - 6.0.0-5
- Resolves: #1548322 - panic: Heketi terminated while performing one or more operations. Server will not start as long as pending operations are present in the db.

* Mon Mar 05 2018 Raghavendra Talur <rtalur@redhat.com> - 6.0.0-4
- Resolves: #1548322 - panic: Heketi terminated while performing one or more operations. Server will not start as long as pending operations are present in the db.

* Thu Feb 22 2018 Raghavendra Talur <rtalur@redhat.com> - 6.0.0-3
- Resolves: #1547917 - [RFE] Rebase heketi to Heketi v6 upstream source

* Wed Feb 21 2018 Raghavendra Talur <rtalur@redhat.com> - 6.0.0-2
- Resolves: #1535922 - Rebase RHGS volmanager container to Heketi v6

* Wed Feb 21 2018 Raghavendra Talur <rtalur@redhat.com> - 6.0.0-1
- Resolves: #1535922 - Rebase RHGS volmanager container to Heketi v6

* Wed Oct 04 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-16
- Resolves: #1497946 - after upgrade from cns 3.5 to 3.6, volume creation fails

* Wed Sep 20 2017 Michael Adam <obnox@redhat.com> - 5.0.0-15
- Resolves: #1490980 - Heketi pod stops working when beging restarted or deleted

* Mon Sep 18 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-14
- Resolves: #1487645 - block-volume creation fails when one of the node is down in a 3 node RHGS cluster
- Resolves: #1492533 - dynamic provisioning of block-volume creation fails

* Mon Sep 18 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-13
- Resolves: #1487645 - block-volume creation fails when one of the node is down in a 3 node RHGS cluster

* Sun Sep 17 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-12
- Resolves: #1487645 - block-volume creation fails when one of the node is down in a 3 node RHGS cluster

* Mon Sep 11 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-11
- Resolves: #1479777 - Return proper status to caller when volume delete is attempted.

* Sat Sep 02 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-10
- Resolves: #1486578 - pre-alloc full option should be set by default for all gluster-block devices
- Resolves: #1485779 - heketi should set group gluster-block option for block-hosting volume
- Resolves: #1480501 - heketi crashed when concurrent operations were performed

* Thu Aug 24 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-9
- Resolves: #1483038 - cns-deployment fails at deploy-heketi phase

* Fri Aug 18 2017 Mohamed Ashiq Liyazudeen <mliyazud@redhat.com> - 5.0.0-8
- Resolves: #1432004 - device remove should check there are no pending heals before proceeding with the brick replacement
- Resolves: #1433614 - cns-deploy fails in case there are "dos" partition signature on devices dedicated for bricks in topology file
- Resolves: #1434668 - After a device is removed from heketi, status of the device reflects as 'failed', which is misleading.
- Resolves: #1435530 - [device remove]: heketi volume info doesn't reflect new volfile server when device remove has replaced a device from a new node
- Resolves: #1468091 - [GSS] Heketi can't detect all storage endpoints available
- Resolves: #1472642 - Heketi : Node remove should wait if heal is in progress.
- Resolves: #1479777 - Return proper status to caller when volume delete is attempted.

* Mon Aug 07 2017 Mohamed Ashiq Liyazudeen <mliyazud@redhat.com> - 5.0.0-7
- Resolves: #1473585 - typo in man heketi-cli
- Resolves: #1477040 - ha count from Cli is not treated correctly in heketi block API
- Resolves: #1441675 - adding node to cns may fail if one of the existing node is down
- Resolves: #1468954 - heketi blockvolume delete fails to delete backend gluster block device but returns success
- Resolves: #1475701 - Error from gluster-block is not propagted back to caller from heketi server.
- Resolves: #1477431 - After Volume Expansion is completed successfully getting write error inside the volume

* Wed Jul 26 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-6
- Resolves: #1468952 - 	heketi block API dont respect "ha" count in the request

* Tue Jul 11 2017 Mohamed Ashiq Liyazudeen <mliyazud@redhat.com> - 5.0.0-5
- Resolves: #1469360 - Initiators fail to detect gluster-block target

* Thu Jul 06 2017 Mohamed Ashiq Liyazudeen <mliyazud@redhat.com> - 5.0.0-4
- Resolves: #1468109 - provide a heketi image with auto_create_block_hosting_volume enabled by default

* Tue Jul 04 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-3
- Resolves: #1467318 - Getting proxy error while deploying heketi pod(pod
                       restarted)

* Thu Jun 29 2017 Mohamed Ashiq Liyazudeen <mliyazud@redhat.com> - 5.0.0-2
- Resolves: #1446069 - [RFE] Enable block volume creation in Heketi

* Wed May 24 2017 Raghavendra Talur <rtalur@redhat.com> - 5.0.0-1
- Resolves: #1440900 - [RFE] Support Volume expansion in Heketi
- Resolves: #1349875 - [RFE] heketi-cli should support replacement of a failed node

* Mon Apr 24 2017 Raghavendra Talur <rtalur@redhat.com> - 4.0.0-9
- Resolves: #1444457 - rebuild heketi to point to new rhgs-volmanager-docker
                       image

* Fri Apr 21 2017 Raghavendra Talur <rtalur@redhat.com> - 4.0.0-8
- Resolves: #1444457 - rebuild heketi to point to new rhgs-volmanager-docker
                       image

* Thu Apr 13 2017 Raghavendra Talur <rtalur@redhat.com> - 4.0.0-7
- Resolves: #1442035 -  rebuild heketi pointing to rhgs-volmanager image with
                        signed builds

* Fri Apr 07 2017 Raghavendra Talur <rtalur@redhat.com> - 4.0.0-6
- Resolves: #1435613 -  heketi remove device fails when the source disk being
                        removed is down
- Resolves: #1437318 -  device info doesn't list all the underlying bricks
                        after concurrent operations such as device remove and
                        volume create are run in parallel
- Resolves: #1439120 -  heketi: failed to start heketi.service

* Thu Mar 30 2017 Raghavendra Talur <rtalur@redhat.com> - 4.0.0-5
- Resolves: #1434838 - heketi-cli command returns error post cns deployment

* Fri Mar 24 2017 Raghavendra Talur <rtalur@redhat.com> - 4.0.0-4
- Resolves: #1434838 - heketi-cli command returns error post cns deployment

* Tue Mar 21 2017 Raghavendra Talur <rtalur@redhat.com> - 4.0.0-3
- Resolves: #1434242 - Upstream image reference in deploy heketi

* Thu Mar 16 2017 Raghavendra Talur <rtalur@redhat.com> - 4.0.0-2
- Resolves: #1415762 - [RFE] heketi-cli should support replacement of a failed
                       devices
- Resolves: #1430678 - heketi device delete command seems to be hung forever
- Resolves: #1430704 - No Space to store heketi DB due to 1MB size limit of
                       secret.
- Resolves: #1431122 - Remove device operation should be allowed only for
                       devices in offline state

* Fri Feb 24 2017 Raghavendra Talur <rtalur@redhat.com> - 4.0.0-1
- Resolves: #1415762 - Remove Device: Used to distribute all the bricks from
                       device to other devices

* Tue Feb 21 2017 Jose A. Rivera <jarrpa@redhat.com> - 4.0.0-1
- Resolves: #1423372 - Rebase Heketi package to upstream v4.

* Mon Jan 09 2017 Raghavendra Talur <rtalur@redhat.com> - 3.1.0-14
- Resolves: #1411397 - all prompts should have default case and work
                       accordingly
- Resolves: #1411227 - Prevent the RHGS docker image in a production setup from
                       getting replaced with any new image with "latest" TAG
                       pushed to the public Registry.

* Mon Jan 09 2017 Raghavendra Talur <rtalur@redhat.com> - 3.1.0-13
- Resolves: #1410782 - strategy: type is seem as "Rolling" instead of
                       "Recreate" while exporting the heketi dc
- Resolves: #1411227 - Prevent the RHGS docker image in a production setup from
                       getting replaced with any new image with "latest" TAG
                       pushed to the public Registry.

* Tue Jan 03 2017 Raghavendra Talur <rtalur@redhat.com> - 3.1.0-12
- Resolves: #1404967 - cns-deploy --abort is not deleting all related resources
- Resolves: #1408685 - Invalid error messages are seen when an incorrect
                       namespace is specified
- Resolves: #1409516 - Option "--cli=oc" fails with error: "Unknown option
                       '-cli=oc'"
- Resolves: #1409520 - Option "--namespace=<NAMESPACE> fails with error:
                       "Unknown option '-namespace=storage-project'."

* Fri Dec 30 2016 Raghavendra Talur <rtalur@redhat.com> - 3.1.0-11
- Resolves: #1389386 - [RFE] Allow non root GIDs ( GID >0 ) to access gluster
                       dynamically provisioned volumes.
- Resolves: #1406701 - cns-deploy tool should first print ALL it's
                       prerequisites before it starts the deployment
- Resolves: #1408410 - Openshift service and endpoints sample files are not
                       found in openshift directory
- Resolves: #1408685 - Invalid error messages are seen when an incorrect
                       namespace is specified
- Resolves: #1408697 - When using --abort option, it should skip the
                       pre-requisites prompt by default (use --yes)
- Resolves: #1409059 - When using --abort option, it's NOT giving a proper
                       warning message before it proceeds with aborting the
                       existing deployment

* Sat Dec 24 2016 Raghavendra Talur <rtalur@redhat.com> - 3.1.0-10
- Resolves: #1406921 - Syntax error in heketi YAML templates

* Fri Dec 23 2016 Raghavendra Talur <rtalur@redhat.com> - 3.1.0-9
- Resolves: #1406310 - Topology load failure should not do abort but quit with
                       a warning

* Fri Dec 23 2016 Raghavendra Talur <rtalur@redhat.com> - 3.1.0-8
- Resolves: #1404948 - Error messages are seen while trying to deploy heketi
                       and GlusterFS
- Resolves: #1404967 - cns-deploy --abort is not deleting all related resources
- Resolves: #1405349 - cns-deploy should use the current namespace instead of
                       using NAMESPACE="default"
- Resolves: #1405403 - cns-deploy tool is NOT throwing proper error message
                       when a router is NOT present or NOT reachable
- Resolves: #1406649 - Reduce the default size of "heketidbstorage" volume from
                       32GB to 2GB
- Resolves: #1406655 - reduce the min-vol size restriction to a lower value
- Resolves: #1406701 - cns-deploy tool should first print ALL it's
                       prerequisites before it starts the deployment
- Resolves: #1406921 - Syntax error in heketi YAML templates
- Resolves: #1406302 - cns-deploy Heketi-cli commands failure in script are not
                       handled
- Resolves: #1406310 - Topology load failure should not do abort but quit with
                       a warning
* Tue Dec 20 2016 Jose A. Rivera <jarrpa@redhat.com> - 3.1.0-7
- Resolves: #1404707 - cns-deploy script should fail to execute if the
                       topology.json file is not in the current directory or if
                       it's actual location is not specified
- Resolves: #1404710 - Multiple "No resources found" messages are getting
                       printed on the screen on executing the cns-deploy script
- Resolves: #1404943 - cns-deploy tool fails to deploy heketi
- Resolves: #1404945 - cns-deploy -g fails to deploy heketi and GlusterFS
- Resolves: #1404948 - Error messages are seen while trying to deploy heketi
                       and GlusterFS
- Resolves: #1404978 - cns-deploy -l doesn't save all output to the specified
                       file
- Resolves: #1404981 - cns-deploy --log <LOG_FILE> fails with error
                       "Unknown option '-log'."
- Resolves: #1405377 - cns-deploy tool should NOT create "glusterfs" template
                       without "-g" option

* Wed Dec 14 2016 Raghavendra Talur <rtalur@redhat.com> - 3.1.0-6
- Resolves: #1404685 - [cns-deploy] Error while executing script-
                       "-bash: /usr/bin/cns-deploy: Permission denied"

* Mon Dec 12 2016 Michael Adam <obnox@redhat.com> - 3.1.0-5
- Resolves: #1401594 - /sys/fs/cgroup is mounted as read write
- Resolves: #1395656 - One of the node in 3 node CNS system fails to respin
                       gluster container after reboot

* Sat Dec 10 2016 Michael Adam <obnox@redhat.com> - 3.1.0-4
- Resolves: #1351535 - Need error logging on volume create failures
- Resolves: #1341961 - heketi server doesn't log errors for node/device delete
- Resolves: #1398578 - Update the man page
- Resolves: #1398581 - gluster-template: '/var/lib/misc/glusterfsd/' fs is not
                       persisted after RHGS container restart
- Resolves: #1402015 - [RFE] provide a cns deployment tool

* Wed Nov 23 2016 Michael Adam <obnox@redhat.com> - 3.1.0-3
- Resolves: #1397793 - Wrong "image" name mentioned in glusterfs-template.json

* Tue Nov 22 2016 Michael Adam <obnox@redhat.com> - 3.1.0-2
- Resolves: #1346621 - topology info: "ID not found" error when
                       running concurrently with volume creation
- Resolves: #1395216 - ProvisioningFailed: Failed to provision volume
                       with StorageClass "gold": glusterfs: create
                       volume err: failed to get hostip Id not found
- Resolves: #1392377 - when multiple pv claim request are made, heketi
                       ends up creating more volumes than requested

* Mon Nov 21 2016 Jose A. Rivera <jarrpa@redhat.com> - 3.1.0-1
- Rebase to version 3.1.0
- Resolves: #1397435 - [RFE] Rebase to heketi 3.1.0
- Resolves: #1351646 - 404: heketi-cli cluster/device/node/volume info

* Fri Oct 28 2016 Jose A. Rivera <jarrpa@redhat.com> - 3.0.0-2
- bz#1359601

* Fri Oct 21 2016 Luis Pabón <lpabon@redhat.com> - 3.0.0-1
- bz#1356437
- bz#1351646
- bz#1351455
- bz#1357686
- bz#1341141
- bz#1346858
- bz#1341961
- bz#1355689
- bz#1370130
- bz#1351893
- bz#1351535

* Fri Oct  21 2016 Luis Pabón <lpabon@redhat.com> - test
- Resolves: #1356437

* Wed Jul 20 2016 Luis Pabón <lpabon@redhat.com> - 2.0.6-1
- bz#1357686
- bz#1355689
- bz#1354342
- bz#1346858
- bz#1357560
- bz#1357357
- bz#1350625
- bz#1272032
- bz#1357604

* Wed Jul 13 2016 Luis Pabón <lpabon@redhat.com> - 2.0.5-1
- bz#1353497

* Fri Jul 08 2016 Luis Pabón <lpabon@redhat.com> - 2.0.4-1
- bz#1351675
- bz#1347693
- bz#1344239
- bz#1348136
- bz#1350670
- bz#1349994
- bz#1341943
- bz#1289108
- bz#1306916

* Mon Jun 20 2016 Luis Pabón <lpabon@redhat.com> - 2.0.2-3
- bz#1306910
- bz#1309620
- bz#1322732
- bz#1337845
- bz#1341943
- bz#1342973
- bz#1347041

* Thu Dec 03 2015 lpabon <lpabon@redhat.com> - 1.0.2-1
- bz#1270773

* Tue Nov 03 2015 lpabon <lpabon@redhat.com> - 1.0.1-1
- bz#1270773

* Mon Oct 12 2015 lpabon <lpabon@redhat.com> - 1.0.0-1
- rhbz#1270773


